View this with StyledEdit at 1024x768 resolution.
----------------------------------------------------------------
Pretendo 0.10a
Public Alpha Release
for BeOS R5 x86
June 05 2000

http://www.pretendo.org/

Pretendo codebase and Windows version by
	- Delta	(Eli Dayan)
	- PrOxY 	(Evan Teran)

BeOS version
	-  Delta	(Eli Dayan)
----------------------------------------------------------------
[notes]

This is a public alpha (yes alpha) release of Pretendo for BeOS.  It is the result of about a month's worth of on and off coding.  Most of the sources have been pulled verbatim out of the Windows source tree, however I had to make plenty of modifications and code a bunch of things from scratch.  This version is more or less in sync with Pretendo 0.10 for Windows, minus a bunch of things/features/what have you, that you probably want.  Come to think of it, this version sucks when compared to the Windows version, but hey, it'll get better, and this is my first BeOS program.


[...hell is this thing?]

Okay.  Simply  put, Pretendo is a Nintendo Entertainment System emulator for x86 (Pentium, namely) based PCs.  The BeOS version is somewhat a port of the Windows version.  Pretendo for BeOS is written in 100% in C++ and Object Oriented C (Besides the 6502 CPU core which is in x86 ASM).  Until I get cooking with NASM, of figure out how to use the maniac inline assembly format in GCC, it will stay this way.  Due to the lack of assembly, the rendering is somewhat slow, but one should attain full speed on a Pentium II, maybe something worse if I lucked out.  Note this is a public ALPHA version.  What does that mean?  Don't expect things to work, period.  Hmmm.... what else.... ah yes, currently, there is no PPC version available, due mainly to the fact that the 6502 CPU core is in x86 Assembly.  Ofcourse there would also be endian issues to work out, but, until I finish my 6502 core in C, and have access to a PPC machine, there won't be.  Pretendo supports iNES format ROM images only.  You should know what those are.


[disclaimerism]

Hmmmmmm....... General disclaimer propganda here.  Something breaks, your fault, not ours. End of story.


[ stuff you may care to read ]

- You do not want to ask us for ROM Images.  Dump them yourself, or find them.  Period.
- You will not send us ROM Images because we don't want them from you.
- The Pretendo source code is not, and probably won't ever be yours.
- We aren't around to provide 24/7 support for your problems.  An email address
    is not a leash.  Don't abuse public information.
- Removing or adding files (noteably ROM images) to the Pretendo archive will result in 
   excommunication.
- Pretendo seems to mean "I pretend" in Spanish.


[ functionality ]

- CPU:
Obviously, the NES's 6502 CPU is emulated.  This is done via Neil Bradley's M6502 core, written in 32-bit Assembly.  This core is pretty damn fast, and I've emitted the core to use built-in bankswitching, as well as handle page 0 writes internally for even more speed.  Unfortunately, there are a few compatibility issues with this core, but you'll have to bear with it until I realize why the core might be choking, or until I finish my C core which I hope will be dead-on-balls accurate, minus some speed ofcourse.

- PPU:
If it weren't for this badboy, there'd be absolutely no graphics, so again, this is obviously emulated.  The PPU, can at times, be quite a bitch to emulate.  This is due to it's bitchy nature, and some missing, or not 100% correct tech info.  That aside, we feel we've done a great job thus far.  We believe our PPU emulation may lie someplace around 90% accurate.  Among the many wonders of this PPU, here's what we've done:
	- Line based rendering engine.  Unlike those tile drawing cheaters.
	- VROM, VRAM
	- Sprites.  8x8 and 8x16 with filipping, and nearly correct priorites.  If bugs make you
	   happy, be sure to check out SMB3.
	- Vertical and Horizontal scrolling, including the proper emulation of the insanity that
	   occurs at PPU adresses $2005, and $2006.
	- Your choice of mirroring.  Vertical, Horizontal, Single Screen (High, Low), and even
	   custom mirroring deals for games that use the MMC5 chipset (not yet  emulated in 
	   this version)
	- The "real" NES palette,  thanks to Kevin Horton.  Some people say it's ugly... but
	   for now that's all there is until I add hue and tint features, or make palettes 
	   selectable.

- APU:
The wiseguys who designed the NES had so gracefully integrated the APU and 6502.  In any case, due to my current (lack of?) BeOS programming knowledge, sound didn't make it into this version.  In fact, the APU core from the Windows version isn't part of the BeOS source tree.  I figured why emulate it if nothing would be heard anyways.  Not too fear, among many, many things I plan to add for the next BeOS version, the APU core and sound output are somewhere at the top of the list ;).

- Memory Mappers:
A NES emulator programmer's worst nightmare.  Another interesting feature (okay, it's more of a design flaw probably) is that the NES has only 64k of address space.  This means, with no extra hardware, the NES can only run small games.  Lucky for us, the elite NES engineers figured out they could expand the small address space by having memory mappers on the carts.  This meant more memory, because mappers are able to bank memory in and out of funky situations, and all over the place.  Some mappers can bank CHR ROM, some PRG ROM, some both, resulting in larger games, better effects/graphics, etc.  Pretendo for BeOS currently only emulates the common mapers found on American carts only.  This might change in the future when I rewrite the mapper interface to be more robust, and expandable.  Pretendo can play most games that house any of the following chipsets.

	Common Board Name:		iNES #:
	NROM					0
	Nintendo MMC1			1
	UNROM					2
	CNROM					3
	Nitnendo MMC3			4
	AOROM					7

- Graphics Engine:
Pretendo for BeOS currently features a BBitmap based drawing engine, intitially provided by Nyef (of DarcNES fame), and then modified by me.  It's not the fastest, nor most customizable engine, but it works, and does it's job for now. Time will allow me to work a lot more on it and make it faster, and better.  Note that I have the drawing synced to 60 frames per second, the refresh rate of NES.

- Input Devices:
Currently, only the first joypad (I/O at $4016) is emulated.  And for now you'll need to use the keyboard until I re-write the input driver to accept other devices such as NES/SNES pads, other joysticks, and so on.  I do have plans for that kind of thing.  Also, note that to Poll input, I am using a Be API called get_key_info(), which unfortunately, is not asynchronous.  This means that Pretendo will be monitoring key input globally, so it can accept input even if it doesn't have focus.  If anyone has a better way to read key input without hooking a BWindow, or BView, please let me know.  In any case, here is the input layout:

	NES Joypad:				PC Keyboard
	Up, Down, Left, Right			The same, respectively, on the keyboard
	Select					Tab Key
	Start						Enter Key
	B						Z Key
	A						X Key

When the input driver is re-written, it'll work a whole lot better, and more importantly, everything will be configurable, so you will be able to use whatever keys you wish.


[ dysfunction ]

This section is a (long) list of things that don't work, and will be fixed for the next version, or at the eariliest possible convinience:

- Threading problems up the wazoo.  If Pretendo crashes, chances are I already know 
   about it.  Suggestions anyone?
- Plenty of features didn't quite make it to this version (Sound, Tools, Configuration, etc...)
- Nearly all the code I wrote for this version, with the exception of the CPU layer needs to 
   be partially, or totally re-written to allow for all the new fun I have planned.
- PPU rendering wants to be in Assembly (just like the windows version)
- PPU wants to be emulated a bit better
- Current mapper support isn't too hot, although a fair amount of American carts work 
   qutie nicely.
- MMC3 implementation has a few IRQ problems.  Due to this, some games will have
   messed graphics. (SMB3, Felix the Cat.....)
- All fuckhacks want to be removed...
- I need to finish my NES 6502 core so that compatibility will go up (and speed down...), 
   and of course for the PPC version
- PrOxY is working on a Linux version
- Probably a bunch of things I forgot.  If you have any suggestions or requests, please 
  contact us.  Note: If the suggestion/request is NES specific, feel free to contact PrOxY
  or myself.  Otherwise, if it is BeOS specific, contact me.


[ i'm the operator, with my pocket calculator ]

Okay.  In all honesty, this thing is dead easy to use.  It's got a GUI for crying out loud, and one should easily be able to figure out how to work it.  Basically, you goto File -> Load ROM Image, then goto CPU -> Run then pray.  The first two can be done through the menu.  If you want some information about a ROM image you loaded, goto File -> ROM Info.  CPU -> Reset will (soft) reset the game.  Help -> About ... well you probably know what that does.  Don't worry.  I know this version is pretty much lame beyond belief since there's not much you can do with it other than play  a couple of games (without sound and game genie cheats, and so on) but the next version should remedy most problems.
	

[ contact information ]

- Email:
	- Delta 	(delta@optonline.net)
	- PrOxY	(emt3734@rit.edu)

- i seek you (ICQ):
	- Delta 	 26295185
	- PrOxY	18345780


[ thank yous ]

Nyef, Neil Bradley, loopy, TNSe, Cricket, trzy, Fx3, y0shi, Firebug, Kevin Horton, Tenesee-Carmel-Vellieux, #bedev, #Emucamp, #that other channel, all our fans, supporters, friends, family, and so on.  And to anyone else forgotten by mistake.

Pretendo Copyright 1999 - 2000 Eli Dayan and Evan Teran  BeOS version released under scanty software.  We are not affiliated with Nintendo of America, or any other such company mentioned in this text.